﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace _139037
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(int)).AutoIncrement = true;
            for (int i = 0; i < 10; i++)
            {

                dt.Columns.Add(string.Format("Column {0}", i), typeof(string)).Expression =
                    string.Format("'ID '+[ID]+' Column {0}'", i);
            }

            for (int i = 0; i < 50; i++)
            {
                dt.Rows.Add();
            }

            ultraGrid1.DataSource = dt;

            int collTotalWidth = ultraGrid1.DisplayLayout.Bands[0].Columns.Cast<UltraGridColumn>().Sum(c => c.Width) + 30;
            int rowHeight = ultraGrid1.Rows.Sum(r => r.Height) + 50;
            ultraGrid1.Width = collTotalWidth;
            ultraGrid1.Height = rowHeight;
            for (int i = 0; i < ultraGrid1.DisplayLayout.Bands[0].Columns.Count; i++)
            {
               // ultraGrid1.Selected.Columns.Add()
                ultraGrid1.DisplayLayout.Bands[0].Columns[i].Header.Selected = (i % 2 == 0);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
           
            if (ultraGrid1.Selected.Columns.Count < 1)
                return;

            Bitmap srcBitmap = new Bitmap(ultraGrid1.Width, ultraGrid1.Height);

            ultraGrid1.DrawToBitmap(srcBitmap, new Rectangle(0,0, srcBitmap.Width, srcBitmap.Height));

              int totalWidthSelectedColls = 0;
              foreach (Infragistics.Win.UltraWinGrid.ColumnHeader coll in ultraGrid1.Selected.Columns)
              {
                  totalWidthSelectedColls += coll.GetUIElement().Rect.Width;
              }

            Bitmap resBitmap = new Bitmap(totalWidthSelectedColls + 10, ultraGrid1.Height);
            Graphics g = Graphics.FromImage(resBitmap);
            Point colBitmapLocation = new Point(0, 0);
            for (int i = 0; i <  ultraGrid1.Selected.Columns.Count; i++)
            {
                UIElement header = ultraGrid1.Selected.Columns[i].GetUIElement();
                Rectangle section = new Rectangle(header.Rect.Location, new Size(header.Rect.Width, ultraGrid1.Height));
                Bitmap collBitmap = Copy(srcBitmap, section);
                g.DrawImage(collBitmap, colBitmapLocation);
                colBitmapLocation.Offset( collBitmap.Width, 0);
                collBitmap.Dispose();
            }

            g.Dispose();
            pictureBox1.Width = resBitmap.Width;
            pictureBox1.Height = resBitmap.Height;
            pictureBox1.Image = resBitmap;
        }

        static public Bitmap Copy(Bitmap srcBitmap, Rectangle section)
        {
            // Create the new bitmap and associated graphics object
            Bitmap bmp = new Bitmap(section.Width, section.Height);
            Graphics g = Graphics.FromImage(bmp);

            // Draw the specified section of the source bitmap to the new one
            g.DrawImage(srcBitmap, 0, 0, section, GraphicsUnit.Pixel);

            // Clean up
            g.Dispose();

            // Return the bitmap
            return bmp;
        }
    }
}
